// @ts-check

const { configure } = require('../../lib/public')

module.exports = configure({
  src: './__tests__/integration/fixtures',
  dest: './__tests__/integration/dest',
  staticFiles: {
    src: 'st',
    dest: './',
  },
  stylesheets: {
    src: 's',
    dest: 's',
    development: {
      sourceMap: true,
    },
    production: {
      sourceMap: false,
    },
  },
  images: {
    src: 'i',
    dest: 'i',
  },
  fonts: {
    src: 'f',
    dest: 'f',
  },
  svg: {
    src: 'sv',
    dest: 'sv',
  },
  html: {
    src: 'h',
    dest: './',
  },
  javascripts: {
    src: 'j',
    dest: 'j',
    entry: ({ resolve: r }) => ({
      // files paths are relative to
      // javascripts.dest in path-config.json
      app: r('./app.js'),
      'ts-app': r('./ts-app.ts'),
      TsApp: r('./TsApp.tsx'),
      JsApp: r('./JsApp.jsx'),
    }),
    production: {
      devtool: false,
    },
  },
  browserSync: {
    server: {
      // should match `dest` in
      // path-config.json
      baseDir: 'public',
    },
  },
  development: {
    open: false,
  },
  production: {
    open: false,
    rev: false,
  },
})
