const cb = jest.fn()
const mockDebug = jest.fn().mockReturnValue(cb)
jest.mock('debug', () => mockDebug)
const mockFancyLog = jest.fn()
jest.mock('fancy-log', () => mockFancyLog)

import { devLogger, devLoggerTitle, logTitle } from '../../gulpfile.ts/lib/loggers'

describe('devLogger', () => {
  it('should log in dev mode', () => {
    devLogger('hello')
    expect(cb).toHaveBeenCalled()
  })
})

describe('devLoggerTitle', () => {
  it('should log a title in dev mode', () => {
    devLoggerTitle('title')
    expect(cb).toHaveBeenCalled()
  })
})

describe('logTitle', () => {
  it('should log a title', () => {
    logTitle('hello')
    expect(mockFancyLog).toHaveBeenCalled()
  })
})
