import * as internal from '../../gulpfile.ts/internal'
import { tsWbformatter } from '../../gulpfile.ts/lib/tsUtils'

jest.mock('../../gulpfile.ts/internal')
jest.mock('path')

describe('tsWbFormatter', () => {
  it('should call getWbMessage', () => {
    const spyGetWbMessage = jest.spyOn(internal, 'getWbMessage')
    const fakeArgs: any = {
      code: 'invalid',
      isWarningSeverity: jest.fn(),
    }
    tsWbformatter(fakeArgs)
    expect(spyGetWbMessage).toHaveBeenCalledWith({
      frame: '',
      fullMessage: undefined,
      messageColor: 'red',
      ruleName: 'TS invalid',
      severityText: 'error',
      symbol: 'err',
    })
  })
})
