"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var internal_1 = require("../internal");
var configPath;
var defaultConfig = path.resolve(internal_1.TIMPLA_PROCESS.TIMPLA_DIR, '.timplaconfig.js');
var userConfig = internal_1.projectPath('.timplaconfig.js');
/** Resolves the timpla config. */
exports.resolveConfig = function () {
    // memoize to only call it once!
    if (configPath) {
        return configPath;
    }
    if (internal_1.TIMPLA_PROCESS.TIMPLA_CONFIG_FILE) {
        configPath = internal_1.projectPath(internal_1.TIMPLA_PROCESS.TIMPLA_CONFIG_FILE);
    }
    else if (fs.existsSync(userConfig)) {
        configPath = userConfig;
    }
    else {
        configPath = defaultConfig;
    }
    return configPath;
};
/**
 * The timpla config.
 */
exports.TIMPLA_CONFIG = internal_1.sureLazyImport(exports.resolveConfig());
//# sourceMappingURL=TIMPLA_CONFIG.js.map