"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var deepmerge = require("deepmerge");
var os = require("os");
var internal_1 = require("../internal");
exports.configure = function (timplaConfig) {
    var conf = internal_1.TIMPLA_DEFAULTS;
    if (timplaConfig) {
        conf = deepmerge(internal_1.TIMPLA_DEFAULTS, timplaConfig, { arrayMerge: internal_1.arrayMerge });
    }
    internal_1.logTitle(chalk_1.default.green("Timpla config used:"), chalk_1.default.blue(internal_1.resolveConfig()), chalk_1.default.yellow("Set the TIMPLA_CONFIG_PATH environment to point to a different config."));
    internal_1.devLoggerTitle("Config dump");
    internal_1.devLogger('%O', conf, os.EOL, os.EOL);
    return conf;
};
//# sourceMappingURL=configure.js.map