"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var internal_1 = require("../internal");
/**
 * Checks if a package is installed.
 * Throws an error if it doesn't (forces the cli to exit).
 * Notifies the user, so that they can install missing deps!
 */
exports.isPackageInstalled = function (packageName) {
    if (!internal_1.PACKAGES_INSTALLED.includes(packageName)) {
        throw Error(chalk_1.default.red("Whoops, please make sure you install " + packageName + ":\nnpm i --save-dev " + packageName));
    }
    return true;
};
//# sourceMappingURL=isPackageInstalled.js.map