"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var internal_1 = require("../internal");
/**
 * A function that can be used to resolve a path relatively to the
 * project directory.
 *
 * We often want to resolve paths relatively to the project root
 * directory. To do that, we use the `INIT_CWD` environment variable
 * provided by Gulp. This variable always resolves to the project
 * root directory so we use it as the seed path and then add the
 * remaining arguments passed and resolving everything using the
 * `path.resolve` function.
 *
 * The returned path is a fully resolved absolute path relative to
 * the project root directory.
 */
exports.projectPath = function () {
    var paths = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paths[_i] = arguments[_i];
    }
    if (paths.length) {
        var cleaned = paths.filter(Boolean);
        return path.resolve.apply(path, __spread([internal_1.TIMPLA_PROCESS.INIT_CWD], cleaned));
    }
    return internal_1.TIMPLA_PROCESS.INIT_CWD;
};
//# sourceMappingURL=projectPath.js.map