"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FsHelper_1 = require("fork-ts-checker-webpack-plugin/lib/FsHelper");
var fs = require("fs");
var internal_1 = require("../internal");
/** Formatter for ForkTSCheckerWebpack */
exports.tsWbformatter = function (message) {
    var file = message.file;
    var rawLines = file && FsHelper_1.FsHelper.existsSync(file) && fs.readFileSync(file, 'utf-8');
    var isError = !message.isWarningSeverity();
    var selector = isError ? 'error' : 'warning';
    var _a = internal_1.errorDisplayHelper[selector], messageColor = _a.messageColor, severityText = _a.severityText, symbol = _a.symbol;
    var frame = rawLines ? internal_1.getFrameColumns(rawLines, message) : '';
    return internal_1.getWbMessage({
        frame: frame,
        fullMessage: message.content,
        messageColor: messageColor,
        ruleName: "TS " + message.code,
        severityText: severityText,
        symbol: symbol,
    });
};
//# sourceMappingURL=tsUtils.js.map